#include "paint.h"

void DrawScreen()
{
 blit(FrameBuf, screen,0,0,0,0,640,480);
}

void PaintFiveStoneBoard()
{
 blit(Board,FrameBuf,0,0,0,0,480,480);
 blit(Title,FrameBuf,0,0,480,0,60,480);
}

void PaintStone(int x, int y, int colour)
{
 if(colour)
 {
  masked_blit(White,FrameBuf,0,0,x*22+32,y*22+32, 17, 17);
 }
 else masked_blit(Black,FrameBuf,0,0,x*22+32,y*22+32, 17, 17);
 play_sample(Click, 255, 0, 1000, 0); 
}

void EraseCursor(int x, int y)
{
 blit(CursorBuf, FrameBuf,0,0,x*22+32, y*22+32, 17,17);
}

void SetCursor(int x, int y)
{
 blit(FrameBuf, CursorBuf, x*22+32, y*22+32,0,0, 17,17);
 PaintShadow(x,y);
}

void PaintShadow(int x, int y)
{
 BITMAP* Shadow = create_bitmap(17,17);
 clear_to_color(Shadow, makecol(50,50,50));

 set_trans_blender(0, 0, 0, 90);
 blit(CursorBuf, FrameBuf, x*22+32, y*22+32, 0, 0, 17, 17);
 draw_trans_sprite(FrameBuf, Shadow, x*22+32, y*22+32);
}


void PaintFromFile(char* theData)
{
 data = load_datafile(theData);

 Black = (BITMAP*)data[0].dat;
 Board = (BITMAP*)data[1].dat;
 Click = (SAMPLE*)data[2].dat;
 Title = (BITMAP*)data[3].dat;
 White = (BITMAP*)data[4].dat;

 FrameBuf = create_bitmap(640, 480);
 clear_to_color(FrameBuf, makecol(0,0,0));
 CursorBuf = create_bitmap(17, 17);
 clear_to_color(CursorBuf, makecol(0,0,0));
}


void initGame()
{
 allegro_init();
 install_timer();
 install_keyboard();	


 int bpp = 32;
 int a;
 int ret = 1;
 static int color_depths[] = { 16, 15, 32, 24, 0 };
 for (a = 0; color_depths[a]; a++) 
 {
  bpp = color_depths[a];
  set_color_depth(bpp);
  ret = set_gfx_mode(GFX_AUTODETECT, 640,480, 0, 0);
  if (ret == 0)
   break;
 }

 if (ret != 0) {
    set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
    allegro_message("Error setting %d bit graphics mode\n%s\n", bpp, allegro_error);
   }

 set_color_conversion(COLORCONV_TOTAL);
 install_sound(DIGI_AUTODETECT, MIDI_AUTODETECT, NULL);	
}

void Shutdown()
{
 destroy_bitmap(Board);
 destroy_bitmap(White);
 destroy_bitmap(Black);
 destroy_bitmap(Title);
 destroy_bitmap(FrameBuf);
 destroy_bitmap(CursorBuf);
 destroy_sample(Click);
 remove_sound();
 allegro_exit();	
}
